Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/HeuristicLab.NativeInterpreter-0.1/DllImporter.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/HeuristicLab.NativeInterpreter-0.1/DllImporter.cs	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/HeuristicLab.NativeInterpreter-0.1/DllImporter.cs	(revision 16350)
@@ -15,5 +15,5 @@
   }
 
-  public class NativeWrapper {
+  public static class NativeWrapper {
     private const string x86dll = "hl-native-interpreter-msvc-x86.dll";
     private const string x64dll = "hl-native-interpreter-msvc-x64.dll";
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/CMakeLists.txt
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/CMakeLists.txt	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/CMakeLists.txt	(revision 16350)
@@ -17,6 +17,6 @@
 
 if(MSVC)
-    target_compile_options(hl-native-interpreter PRIVATE "/W4" "/Qvec-report:2" "$<$<CONFIG:Release>:/O2>")
-    target_compile_options(hl-native-interpreter-vdt PRIVATE "/W4" "/Qvec-report:2" "$<$<CONFIG:Release>:/O2>")
+    target_compile_options(hl-native-interpreter PRIVATE "/W4" "/Qvec-report:2" "/MT" "$<$<CONFIG:Release>:/O2>")
+    target_compile_options(hl-native-interpreter-vdt PRIVATE "/W4" "/Qvec-report:2" "/MT" "$<$<CONFIG:Release>:/O2>")
     target_compile_definitions(hl-native-interpreter-vdt PRIVATE "USE_VDT")
 else()
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.cpp	(revision 16350)
@@ -50,9 +50,6 @@
     if (remainingRows > 0) 
     {
-        for (int rowIndex = total; rowIndex < totalRows; rowIndex += remainingRows)
-        {
-            evaluate(code, codeLength, rows, rowIndex, remainingRows);
-            std::memcpy(result + rowIndex, code[0].buf, remainingRows * sizeof(double));
-        }
+        evaluate(code, codeLength, rows, total, remainingRows);
+        std::memcpy(result + total, code[0].buf, remainingRows * sizeof(double));
     }
     _aligned_free(buffer);
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.ExtLibs/HeuristicLab.NativeInterpreter/0.1/NativeInterpreter-0.1/src/interpreter.h	(revision 16350)
@@ -101,4 +101,9 @@
                     break;
                 }
+            case OpCodes::Square:
+                {
+                    in.value = std::pow(code[in.childIndex].value, 2.);
+                    break;
+                }
             case OpCodes::Sqrt:
                 {
@@ -257,5 +262,5 @@
             case OpCodes::Sqrt:
                 {
-                    pow(in.buf, code[in.childIndex].buf, 1./2.);
+                    sqrt(in.buf, code[in.childIndex].buf);
                     break;
                 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/Plugin.cs.frame	(revision 16350)
@@ -24,4 +24,6 @@
 using System.Text;
 using HeuristicLab.PluginInfrastructure;
+using System.Runtime.InteropServices;
+using System.IO;
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
@@ -47,4 +49,20 @@
   [PluginDependency("HeuristicLab.Problems.DataAnalysis.Symbolic", "3.4")]
   public class HeuristicLabProblemsDataAnalysisSymbolicViewsPlugin : PluginBase {
+    // HeuristicLab is marked with zone identifier 'Internet' after download.
+    // This propagates to all extracted files and can be checked in the file properties.
+    // IE prevents execution of MathJax JavaScript inside of untrusted html
+    // Therefore we need to programmatically unblock the displayModelFrame.html file before extracting.
+    // see http://engram404.net/programmatically-unblocking-downloaded-files/
+
+    // for removing the Zone.Identifier alternative NTFS stream (effectively unblocking the file)
+    [DllImport("kernel32.dll", SetLastError = true)]
+    private static extern bool DeleteFile(string lpFileName);
+
+    public override void OnLoad() {
+      base.OnLoad();
+
+      // unblock mathjax.zip () 
+      DeleteFile(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "displayModelFrame.html:Zone.Identifier"));
+    }
   }
 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html	(revision 16349)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/displayModelFrame.html	(revision 16350)
@@ -7,5 +7,5 @@
     <meta http-equiv="X-UA-Compatible" content="IE=edge" />
     <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
-    <meta name="viewport" content="width=device-width, initial-scale=1">
+    <meta name="viewport" content="width=device-width, initial-scale=1" />
 
     <!-- title change by HEAL -->
@@ -46,5 +46,5 @@
         <hr>
     </noscript>
-    <p id="model">
+    <p id="model">$\cos(x^2)$
     </p>
 </body>