Index: branches/2966_interval_calculation/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs
===================================================================
--- branches/2966_interval_calculation/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs	(revision 16373)
+++ branches/2966_interval_calculation/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalInterpreter.cs	(revision 16374)
@@ -149,33 +149,33 @@
       Interval> intervals = null) {
       Instruction currentInstr = instructions[InstructionCount++];
-      Interval intermediate = null;
+      Interval result = null;
 
       switch (currentInstr.opCode) {
         //Elementary arithmetic rules
         case OpCodes.Add: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Add(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Add(result, Evaluate(instructions, intervals));
             }
             break;
           }
         case OpCodes.Sub: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Subtract(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Subtract(result, Evaluate(instructions, intervals));
             }
             break;
           }
         case OpCodes.Mul: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Multiply(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Multiply(result, Evaluate(instructions, intervals));
             }
             break;
           }
         case OpCodes.Div: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Divide(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Divide(result, Evaluate(instructions, intervals));
             }
             break;
@@ -183,44 +183,44 @@
         //Trigonometric functions
         case OpCodes.Sin: {
-            intermediate = Interval.Sine(Evaluate(instructions, intervals));
+            result = Interval.Sine(Evaluate(instructions, intervals));
             break;
           }
         case OpCodes.Cos: {
-            intermediate = Interval.Cosine(Evaluate(instructions, intervals));
+            result = Interval.Cosine(Evaluate(instructions, intervals));
             break;
           }
         case OpCodes.Tan: {
-            intermediate = Interval.Tangens(Evaluate(instructions, intervals));
+            result = Interval.Tangens(Evaluate(instructions, intervals));
             break;
           }
         //Exponential functions
         case OpCodes.Log: {
-            intermediate = Interval.Logarithm(Evaluate(instructions, intervals));
+            result = Interval.Logarithm(Evaluate(instructions, intervals));
             break;
           }
         case OpCodes.Exp: {
-            intermediate = Interval.Exponential(Evaluate(instructions, intervals));
+            result = Interval.Exponential(Evaluate(instructions, intervals));
             break;
           }
         case OpCodes.Power: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Power(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Power(result, Evaluate(instructions, intervals));
             }
             break;
           }
         case OpCodes.Square: {
-            intermediate = Interval.Square(Evaluate(instructions, intervals));
+            result = Interval.Square(Evaluate(instructions, intervals));
             break;
           }
         case OpCodes.Root: {
-            intermediate = Evaluate(instructions, intervals);
-            for (int i = 1; i < currentInstr.nArguments; i++) {
-              intermediate = Interval.Root(intermediate, Evaluate(instructions, intervals));
+            result = Evaluate(instructions, intervals);
+            for (int i = 1; i < currentInstr.nArguments; i++) {
+              result = Interval.Root(result, Evaluate(instructions, intervals));
             }
             break;
           }
         case OpCodes.SquareRoot: {
-            intermediate = Interval.SquareRoot(Evaluate(instructions, intervals));
+            result = Interval.SquareRoot(Evaluate(instructions, intervals));
             break;
           }
@@ -241,6 +241,6 @@
 
       if (intervals != null)
-        intervals.Add(currentInstr.dynamicNode, intermediate);
-      return intermediate;
+        intervals.Add(currentInstr.dynamicNode, result);
+      return result;
     }
 